searchNodes=[{"doc":"A keyword lens is a nested keyword-like structure used to describe paths into certain data types. It is similar to the list you can provide to Ecto's Repo.preload/2You can describe a KeywordLens like this: [a: :b, c: [d: :e]]Such a list is handy for describing a subset of a nested map structure. For example, you can imagine the following path: [a: :b] applied to this map: %{a: %{b: 1}} points to the value 1.It's not a proper Keyword list because we allow string keys for convenience, so this is valid:[{&quot;a&quot;, :b}]In effect the list is a list of paths to values contained in a given data structure. This is useful for describing changes that should apply to a subset of a nested data structure.ExamplesHere are some examples of different KeywordLenses and the unique set of paths they represent.lens = [a: :b] paths = [:a, :b] lens = [a: [b: [:c, :d]]] paths = [[:a, :b, :c], [:a, :b, :d]] lens = [a: [:z, b: [:c, d: :e]]] paths = [[:a, :z], [:a, :b, :c], [:a, :b, :d, :e]] lens = [:a, &quot;b&quot;, :c] paths = [[:a], [&quot;b&quot;], [:c]]","ref":"KeywordLens.html","title":"KeywordLens","type":"protocol"},{"doc":"Should replace the values found at the end of each of the paths in data with the result of fun called with the data found at the end of that path. An example for maps is shown below.Examplesiex&gt; KeywordLens.map(%{a: %{b: 1}}, [a: :b], &amp;(&amp;1 + 1)) %{a: %{b: 2}}","ref":"KeywordLens.html#map/3","title":"KeywordLens.map/3","type":"function"},{"doc":"","ref":"KeywordLens.html#map_while/3","title":"KeywordLens.map_while/3","type":"function"},{"doc":"","ref":"KeywordLens.html#reduce_while/4","title":"KeywordLens.reduce_while/4","type":"function"},{"doc":"","ref":"KeywordLens.html#t:t/0","title":"KeywordLens.t/0","type":"type"},{"doc":"The naming is a bit strange because I can't use the same name as the procotol. This is essentially helper functions for KeywordLenses that might span protocol implementations.","ref":"KeywordLens.Helpers.html","title":"KeywordLens.Helpers","type":"module"},{"doc":"Takes a KeywordLens and turns it into a list of all of the lenses the KeywordLens describes.Examplesiex&gt; KeywordLens.Helpers.expand([a: :b]) [[:a, :b]] iex&gt; KeywordLens.Helpers.expand([a: [b: [:c, :d]]]) [[:a, :b, :d], [:a, :b, :c]] iex&gt; KeywordLens.Helpers.expand([a: [:z, b: [:c, d: :e]]]) [[:a, :b, :d, :e], [:a, :b, :c], [:a, :z]] iex&gt; KeywordLens.Helpers.expand([:a, &quot;b&quot;, :c]) [[:c], [&quot;b&quot;], [:a]]","ref":"KeywordLens.Helpers.html#expand/1","title":"KeywordLens.Helpers.expand/1","type":"function"},{"doc":"","ref":"KeywordLens.InvalidPathError.html","title":"KeywordLens.InvalidPathError","type":"exception"},{"doc":"","ref":"KeywordLens.InvalidReducingFunctionError.html","title":"KeywordLens.InvalidReducingFunctionError","type":"exception"}]